#pragma once
#include <iostream>
#include <vector>



class NeuralNetwork {
    int numInputs;
    int numHidden;
    int numOutputs;
    std::vector<double> inputs;
    std::vector<double> hidden;
    std::vector<double> outputs;
    std::vector<std::vector<double>> weightsInputHidden;
    std::vector<std::vector<double>> weightsHiddenOutput;

public:
    // Constructor
    NeuralNetwork(int nI, int nH, int nO);

    // Feedforward function
    void feedForward(std::vector<double>& inputs);

    // Backpropagation function
    void backPropagate(std::vector<double>& targets);

    // Get the output of the neural network
    std::vector<double> getOutput();

    // Activation function
    double sigmoid(double x);

    // Derivative of the activation function
    double sigmoidDerivative(double x);
};